using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

using Syncfusion.Windows.Forms.Grid;

namespace MaskEditCells
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		private System.Windows.Forms.Button PrintPreview;
		private System.Windows.Forms.PropertyGrid propertyGrid1;
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();

			//register custom celltype
			gridControl1.CellModels.Add("MaskEdit", new GridMaskEditCellModel(gridControl1.Model));
			gridControl1.BackColor = Color.FromArgb(0xda, 0xe5, 0xf5);

			for (int row = 2; row <= 10; row++)
			{
				GridStyleInfo style = gridControl1[row, 2];
				style.CellType = "MaskEdit";
				GridMaskEditStyleProperties mcs = new GridMaskEditStyleProperties(style);
				mcs.MaskEdit.Mask = "99-99-99";
			}

			gridControl1[2, 3].Text = "First Name";
			GridStyleInfo style1 = gridControl1[2, 4];
			GridMaskEditInfo maskedEditStyle1 = (new GridMaskEditStyleProperties(style1)).MaskEdit;
			gridControl1[4, 3].Text = "Last Name";
			GridStyleInfo style2 = gridControl1[4, 4];
			GridMaskEditInfo maskedEditStyle2 = (new GridMaskEditStyleProperties(style2)).MaskEdit;
			gridControl1[6, 3].Text = "Telephone";
			GridStyleInfo style3 = gridControl1[6, 4];
			GridMaskEditInfo maskedEditStyle3 = (new GridMaskEditStyleProperties(style3)).MaskEdit;
			gridControl1[8, 3].Text = "Social Security";
			GridStyleInfo style4 = gridControl1[8, 4];
			GridMaskEditInfo maskedEditStyle4 = (new GridMaskEditStyleProperties(style4)).MaskEdit;

			// 
			// maskedEditBox1
			// 
			style1.CellType = "MaskEdit";
			maskedEditStyle1.AllowPrompt = false;
			maskedEditStyle1.ClipMode = Syncfusion.Windows.Forms.Tools.ClipModes.ExcludeLiterals;
			style1.CultureInfo = new System.Globalization.CultureInfo("en-US");
			maskedEditStyle1.DateSeparator = '-';
			maskedEditStyle1.Mask = ">C<CCCCCCCCCCCC";
			style1.MaxLength = 13;
			maskedEditStyle1.SpecialCultureValue = Syncfusion.Windows.Forms.Tools.SpecialCultureValues.None;
			maskedEditStyle1.UseLocaleDefault = false;
			maskedEditStyle1.UseUserOverride = true;
			// 
			// maskedEditBox2
			// 
			style2.CellType = "MaskEdit";
			maskedEditStyle2.AllowPrompt = false;
			maskedEditStyle2.ClipMode = Syncfusion.Windows.Forms.Tools.ClipModes.IncludeLiterals;
			style2.CultureInfo = new System.Globalization.CultureInfo("en-US");
			maskedEditStyle2.DateSeparator = '-';
			maskedEditStyle2.Mask = "CCCCCCCCCCCCC";
			style2.MaxLength = 13;
			maskedEditStyle2.SpecialCultureValue = Syncfusion.Windows.Forms.Tools.SpecialCultureValues.None;
			style2.Text = "_____________";
			maskedEditStyle2.UseLocaleDefault = false;
			maskedEditStyle2.UseUserOverride = true;
			// 
			// maskedEditBox3
			// 
			style3.CellType = "MaskEdit";
			maskedEditStyle3.AllowPrompt = false;
			maskedEditStyle3.ClipMode = Syncfusion.Windows.Forms.Tools.ClipModes.IncludeLiterals;
			style3.CultureInfo = new System.Globalization.CultureInfo("en-US");
			maskedEditStyle3.DateSeparator = '-';
			maskedEditStyle3.Mask = "(999) 999 - 9999";
			style3.MaxLength = 16;
			maskedEditStyle3.SpecialCultureValue = Syncfusion.Windows.Forms.Tools.SpecialCultureValues.None;
			style3.Text = "(___) ___ - ____";
			maskedEditStyle3.UseLocaleDefault = false;
			maskedEditStyle3.UseUserOverride = true;
			// 
			// maskedEditBox4
			// 
			style4.CellType = "MaskEdit";
			maskedEditStyle4.AllowPrompt = false;
			maskedEditStyle4.ClipMode = Syncfusion.Windows.Forms.Tools.ClipModes.IncludeLiterals;
			style4.CultureInfo = new System.Globalization.CultureInfo("en-US");
			maskedEditStyle4.DateSeparator = '-';
			maskedEditStyle4.Mask = "999-99-9999";
			style4.MaxLength = 11;
			maskedEditStyle4.SpecialCultureValue = Syncfusion.Windows.Forms.Tools.SpecialCultureValues.None;
			style4.Text = "___-__-____";
			maskedEditStyle4.UseLocaleDefault = false;
			maskedEditStyle4.UseUserOverride = true;


			this.propertyGrid1.CausesValidation = false;
		}			

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.PrintPreview = new System.Windows.Forms.Button();
			this.propertyGrid1 = new System.Windows.Forms.PropertyGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.gridControl1.ColCount = 12;
			this.gridControl1.HorizontalThumbTrack = true;
			this.gridControl1.Location = new System.Drawing.Point(24, 48);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.RowCount = 120;
			this.gridControl1.Size = new System.Drawing.Size(392, 264);
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			this.gridControl1.VerticalThumbTrack = true;
			this.gridControl1.CurrentCellMoved += new Syncfusion.Windows.Forms.Grid.GridCurrentCellMovedEventHandler(this.gridControl1_CurrentCellMoved);
			// 
			// PrintPreview
			// 
			this.PrintPreview.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.PrintPreview.Location = new System.Drawing.Point(208, 16);
			this.PrintPreview.Name = "PrintPreview";
			this.PrintPreview.Size = new System.Drawing.Size(240, 23);
			this.PrintPreview.TabIndex = 1;
			this.PrintPreview.Text = "PrintPreview";
			this.PrintPreview.Click += new System.EventHandler(this.PrintPreview_Click);
			// 
			// propertyGrid1
			// 
			this.propertyGrid1.CommandsVisibleIfAvailable = true;
			this.propertyGrid1.LargeButtons = false;
			this.propertyGrid1.LineColor = System.Drawing.SystemColors.ScrollBar;
			this.propertyGrid1.Location = new System.Drawing.Point(440, 48);
			this.propertyGrid1.Name = "propertyGrid1";
			this.propertyGrid1.Size = new System.Drawing.Size(208, 264);
			this.propertyGrid1.TabIndex = 2;
			this.propertyGrid1.Text = "propertyGrid1";
			this.propertyGrid1.ViewBackColor = System.Drawing.SystemColors.Window;
			this.propertyGrid1.ViewForeColor = System.Drawing.SystemColors.WindowText;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(664, 333);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.propertyGrid1,
																		  this.gridControl1,
																		  this.PrintPreview});
			this.Name = "Form1";
			this.Text = "Masked Edit Cells...";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		public static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
		}

		private void PrintPreview_Click(object sender, System.EventArgs e)
		{
			if (gridControl1 != null)
			{
				try 
				{
					GridPrintDocument pd = new GridPrintDocument(gridControl1, true); //Assumes the default printer

					PrintPreviewDialog dlg = new PrintPreviewDialog() ;
					dlg.Document = pd;
					dlg.ShowDialog();
				} 
				catch(Exception ex) 
				{ 
					MessageBox.Show("An error occurred attempting to preview the file to print - " + ex.Message);
				}
			}

		}

		private void gridControl1_CurrentCellMoved(object sender, Syncfusion.Windows.Forms.Grid.GridCurrentCellMovedEventArgs e)
		{
			this.propertyGrid1.SelectedObject = this.gridControl1[gridControl1.CurrentCell.RowIndex, gridControl1.CurrentCell.ColIndex];
		}
	}
}
